%define oname		cprops

%define major		15
%define libname		%mklibname %{oname} %{major}
%define develname	%mklibname -d %{oname}

%define dbms_major	0
%define mysqllib	%mklibname cp_dbms_mysql %{dbms_major}
%define pgreslib	%mklibname cp_dbms_postgres %{dbms_major}

%bcond_without	postgres
%bcond_without	mysql

Name:		lib%{oname}
Version:	0.1.12
Release:	%mkrel 21

Summary:	C Prototyping Tools
Group:		Development/C
License:	LGPLv2+
URL:		https://%{oname}.sourceforge.net/
Source0:	https://downloads.sourceforge.net/%{oname}/%{name}-%{version}.tar.bz2
Patch0:		libcprops-AC_DEFINE.patch
Patch1:		libcprops-format-string.patch
Patch2:		libcprops-fix-building-with-gcc14.patch

BuildRequires:	pkgconfig(openssl)
BuildRequires:	flex
BuildRequires:	bison

%description
The C Prototyping Tools library provides thread-safe linked list, priority
queue, hash table, hash list, AVL tree and trie implementations, as well
as a thread pool and a thread management framework, a TCP and an HTTP socket
API, and a DBMS abstraction layer.

%package -n %{libname}
Summary:	C Prototyping Tools
Group:		System/Libraries
Obsoletes:	%{_lib}libcprops0 < 0.1.12-3

%if %with mysql
%package -n %{mysqllib}
Summary:	MySQL (MariaDB) dbms driver for %{name}
Group:		System/Libraries
BuildRequires:	mysql-devel

%description -n %{mysqllib}
This package contains the MySQL (MariaDB) dbms driver for %{name}.
%endif

%if %with postgres
%package -n %{pgreslib}
Summary:	PostgreSQL dbms driver for %{name}
Group:		System/Libraries
BuildRequires:	postgresql-devel
Conflicts:	%{_lib}libcprops0 < 0.1.12-3

%description -n %{pgreslib}
This package contains the PostgreSQL dbms driver for %{name}.
%endif

%description -n %{libname}
The C Prototyping Tools library provides thread-safe linked list, priority
queue, hash table, hash list, AVL tree and trie implementations, as well
as a thread pool and a thread management framework, a TCP and an HTTP socket
API, and a DBMS abstraction layer.

%package -n %{develname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Obsoletes:	%{_lib}libcprops-devel < 0.1.12-3

%description -n %{develname}
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q
%autopatch -p1

# for autoreconf
mkdir -p m4

%build
autoreconf -vfi
%configure \
	--disable-static \
	--disable-cpsvc \
	--disable-cpsp \
	--enable-shared \
	--with-ssl=%{_prefix} \
	%{?with_postgres:--with-postgres-includes=%{_includedir}/pgsql} \
	%{?with_postgres:--with-postgres-libs=%{_libdir}} \
	%{?with_mysql:--with-mysql-includes=%{_includedir}/mysql} \
	%{?with_mysql:--with-mysql-libs=%{_libdir}}

sed -e 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' \
    -e 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' \
    -e 's|func_apped|func_append|' \
    -e 's|CC -shared|CC -shared -Wl,--as-needed|g' \
    -i libtool

%make_build

%install
%make_install

# we don't want these
find %{buildroot} -name "*.la" -delete

%files -n %{libname}
%doc README ChangeLog
%{_libdir}/%{name}.so.%{major}
%{_libdir}/%{name}.so.%{major}.*

%if %with mysql
%files -n %{mysqllib}
%{_libdir}/libcp_dbms_mysql.so.%{dbms_major}
%{_libdir}/libcp_dbms_mysql.so.%{dbms_major}.*
%endif

%if %with postgres
%files -n %{pgreslib}
%{_libdir}/libcp_dbms_postgres.so.%{dbms_major}
%{_libdir}/libcp_dbms_postgres.so.%{dbms_major}.*
%endif

%files -n %{develname}
%{_mandir}/man3/*
%{_includedir}/%{oname}/
%{_libdir}/*.so


%changelog
* Fri Oct 18 2024 ns80 <ns80> 0.1.12-21.mga10
+ Revision: 2107893
- try to fix building with GCC 14

* Sat Apr 02 2022 umeabot <umeabot> 0.1.12-20.mga9
+ Revision: 1841122
- Mageia 9 Mass Rebuild

* Sat Oct 02 2021 wally <wally> 0.1.12-19.mga9
+ Revision: 1747459
- rebuild for openssl 3.0.0

* Wed Aug 05 2020 joequant <joequant> 0.1.12-18.mga8
+ Revision: 1611118
- fix deps

* Thu Feb 13 2020 umeabot <umeabot> 0.1.12-17.mga8
+ Revision: 1513948
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sun Sep 23 2018 umeabot <umeabot> 0.1.12-16.mga7
+ Revision: 1298793
- Mageia 7 Mass Rebuild

* Sat Jun 09 2018 wally <wally> 0.1.12-15.mga7
+ Revision: 1235630
- fix build on aarch64
+ kekepower <kekepower>
- Use new make macros

* Sat Dec 23 2017 wally <wally> 0.1.12-14.mga7
+ Revision: 1184224
- rebuild for new mariadb

* Sat Sep 09 2017 cjw <cjw> 0.1.12-13.mga7
+ Revision: 1152096
- rebuild for openssl 1.1

* Wed Mar 02 2016 umeabot <umeabot> 0.1.12-12.mga6
+ Revision: 983564
- Rebuild for openssl

* Mon Feb 08 2016 umeabot <umeabot> 0.1.12-11.mga6
+ Revision: 950854
- Mageia 6 Mass Rebuild

* Tue Nov 25 2014 cjw <cjw> 0.1.12-10.mga5
+ Revision: 798933
- rebuild against postgresql9.4

* Wed Oct 15 2014 umeabot <umeabot> 0.1.12-9.mga5
+ Revision: 747097
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 0.1.12-8.mga5
+ Revision: 726698
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 0.1.12-7.mga5
+ Revision: 681387
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 0.1.12-6.mga4
+ Revision: 528200
- Mageia 4 Mass Rebuild

* Sun Jun 16 2013 wally <wally> 0.1.12-5.mga4
+ Revision: 443755
- build dbms drivers

* Sun Jun 16 2013 wally <wally> 0.1.12-4.mga4
+ Revision: 443689
- obsolete wrongly named devel pkg

* Sun Jun 16 2013 wally <wally> 0.1.12-3.mga4
+ Revision: 443672
- fix libification
- disable postgres build for now
- add patch to fix build when using autoreconf
- clean .spec a bit

* Sat Jan 12 2013 umeabot <umeabot> 0.1.12-2.mga3
+ Revision: 356928
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 15 2012 shlomif <shlomif> 0.1.12-1.mga3
+ Revision: 331213
- Made the package more Mageia-like
- import based on the Fedora RawHide package.


* Tue Jan 31 2012 Philip Prindeville <philipp@fedoraproject.org> 0.1.12-1.1
 - Fix build issues on EL6 with older libtool.

* Mon Jan 23 2012 Philip Prindeville <philipp@fedoraproject.org> 0.1.12-1
 - Version bump which fixes "library calling exit()" warning from rpmlint.

* Mon Jan 09 2012 Philip Prindeville <philipp@fedoraproject.org> 0.1.11-1
 - Fix review comments.

* Fri Dec 09 2011 Philip Prindeville <philipp@fedoraproject.org> 0.1.10-0.1
 - Enable trie module.

* Thu Nov 10 2011 Philip Prindeville <philipp@fedoraproject.org> svn36-0.1
 - Fixes for documentation warnings.
 - Fixes for compiler warnings.

* Sun Oct 30 2011 Philip Prindeville <philipp@fedoraproject.org> 0.1.8-0.1
 - Initial packaging.
